/**
 * Experimental scripts used to get airplane interpolation values
 * Full of smell and console logs, I know :)
 */

const add = a => b => a + b
const multiply = a => b => a * b

const range = n => {
  const arr = []

  for (let i = 0; i < n; i++) {
    arr[i] = i
  }

  return arr
}

const zip = (a, b) => {
  const arr = []

  for (let i = 0; i < a.length; i++) {
    arr[i] = [a[i], b[i]]
  }

  return arr
}

const vectorAdd = a => b => zip(a, b).map(([x, y]) => x + y)
const vectorScalarMultiply = n => v => v.map(multiply(n))

const round = (x, decimalPlaces = 0) =>
  Math.round(x * Math.pow(10, decimalPlaces)) / Math.pow(10, decimalPlaces)

const roundVector = v => v.map(x => round(x, 2))

const intermediateValues = (a, b, numOfValues = 2) => {
  const difference = b - a

  return range(numOfValues).map(
    (_, i) => a + i / (numOfValues - 1) * difference,
  )
}

const circlePoints = (
  numOfPoints = 4,
  xBase = 1,
  yBase = 1,
  startAngle = 0,
  endAngle = 2 * Math.PI,
) => {
  console.log(
    'ANGLES',
    intermediateValues(
      startAngle + Math.PI / 2,
      endAngle + Math.PI / 2,
      numOfPoints + 1,
    ).map(x => round(x, 2))
    .reverse()
    .map(x => '0 1 0 ' + x + ', ')
    .reduce((acc, x) => acc + x),
  )

  return intermediateValues(startAngle, endAngle, numOfPoints + 1)
    .map(angle => [xBase * Math.cos(angle), yBase * Math.sin(angle)])
    .map(roundVector)
}

const cornerPoints = (num = 16, radius = 10, gapSize = 36) => {
  const pointsPerSide = num / 2

  return [1, -1].map(sign =>
    circlePoints(
      pointsPerSide,
      radius,
      radius,
      sign * ((sign === 1 ? 0 : Math.PI) + -Math.PI / 2),
      sign * ((sign === 1 ? 0 : Math.PI) + Math.PI / 2),
    ).map(vectorAdd([sign * gapSize / 2, 0])),
  )
}

// console.log(cornerPoints(8))
console.log(
  '0 0 0,' +
    cornerPoints()
      .map(_ => _.map(v => [v[0], 0, v[1]]))
      .reduce(
        (acc, item) =>
          acc +
          String(
            item.reduce(
              (acc2, x) =>
                acc2 + x.reduce((acc3, y) => acc3 + ' ' + y, '') + ',',
              '',
            ),
          ) +
          ' 0 0 0,',
        '',
      ),
)

// const arr = [0,0,0,  4,0,-1,4.71,0,-0.71,5,0,0,4.71,0,0.71,4,0,1,  0,0,0,  -4,0,1,-3.29,0,0.71,-3,0,0,-3.29,0,-0.71,-4,0,-1,  0,0,0,]

// const times__ = [0,  0.13,0.19,0.25,0.31,0.37,  0.5,  0.63,0.69,0.75,0.81,0.87,  1]

const times = () => {
  const cornerDelta = 0.03
  const gapTime = 1 - 16 * cornerDelta
  const cornerTimes = range(2).map(c =>
    range(9)
      .map(i => gapTime / 4 + c * 0.5 + i * cornerDelta)
      .map(x => round(x, 2)),
  )
  return cornerTimes
}

console.log(
  times().reduce(
    (acc, item) =>
      acc + String(item.reduce((acc3, y) => acc3 + ' ' + y, '')) + ' SPACE',
    '',
  ),
)
